/* Sistemas Integrados TEKNISA

Nome: 8830_SUPTRGS.sql

Descrio:
Trigger para incluso de todos os fornecedores na
tabela REFORFIL para a filial que estiver sendo inserida.

Com essa trigger, ao incluir uma filial, automaticamente o sistema ir
considerar que nenhum fornecedor atende  mesma.

Criao:
07/12/2004 Marcelo Alexsandro Souza Silva
*/

IF EXISTS (SELECT
              NAME
           FROM
              SYSOBJECTS
           WHERE
              NAME = 'GRAVA_REFORFIL_FILIAL' AND
              TYPE = 'TR')
   DROP TRIGGER GRAVA_REFORFIL_FILIAL
GO

CREATE TRIGGER GRAVA_REFORFIL_FILIAL
ON FILIAL
FOR INSERT, UPDATE

AS

DECLARE @V_NEW_CDFILIAL VARCHAR(04);
DECLARE @V_CDFORNECED   VARCHAR(21);

BEGIN
   DECLARE C_INSERTED CURSOR FOR
      SELECT
         INSERTED.CDFILIAL
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED)

      UNION ALL

      SELECT
         INSERTED.CDFILIAL
      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDFILIAL = DELETED.CDFILIAL  AND
         INSERTED.CDREGIAO <> DELETED.CDREGIAO;
   OPEN C_INSERTED;
   FETCH NEXT FROM C_INSERTED INTO @V_NEW_CDFILIAL;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      UPDATE
         REFORFIL
      SET
         CDPERIENTR = NULL
      WHERE
         CDFILIAL = @V_NEW_CDFILIAL;

      INSERT INTO
         REFORFIL (CDFORNECED, CDFILIAL)
      SELECT
         F.CDFORNECED,
         @V_NEW_CDFILIAL
      FROM
         FORNECEDOR F
      WHERE
         NOT EXISTS
            (SELECT
                1
             FROM
                REFORFIL R
             WHERE
                R.CDFILIAL   = @V_NEW_CDFILIAL AND
                R.CDFORNECED = F.CDFORNECED
             );

      FETCH NEXT FROM C_INSERTED INTO @V_NEW_CDFILIAL;
   END;
   CLOSE C_INSERTED;
   DEALLOCATE C_INSERTED;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GRAVA_REFORFIL_FILIAL','4.09.073';
GO

